//+------------------------------------------------------------------+
//|                                                     first-ea.mq4 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <Arrays/ArrayDouble.mqh>

//--- input parameters
input int      TakeProfit=50;
input int      StopLoss1=50;
//input double   LotSize=0.1;
input int      Slippage=3;
input int      MagicNumber=5555;
input int      TP1=1;
input int      TP2=2;
input int      TP3=3;
input int      SL1=1;
input int      SL2=2;
input int      SL3=3;
input int      Distance=50;
input int      BreakEvenusd=50;


//--- indicator inputs
sinput string        indi = "";                // ------ Indicators -----  

input int            MA_Period1  = 48;         // MA Period
input ENUM_MA_METHOD MA_Method1  = MODE_SMA;    // MA Method
input int            MA_Period2  = 144;         // MA Period
input ENUM_MA_METHOD MA_Method2  = MODE_SMA;    // MA Method
//input int      BreakEvenusd=10;

//--- global variable
double MyPoint;
int PointstoPips;
int    MySlippage;
//string emptyarray[10];
//int em=EMPTY_VALUE;
extern int EndHour = 23;
extern int StartHour = 1;
bool StopTrading;
double SI(int buff,int shift){ return(iCustom(NULL,PERIOD_H4,"tales",buff,shift));}
//double num_array[];
//double num_array1[];

  
double CalculateLotSize(double SL)
{          //Calculate the size of the position size 
   double LotSize=0;
   //We get the value of a tick
   double nTickValue=MarketInfo(Symbol(),MODE_TICKVALUE);
   //If the digits are 3 or 5 we normalize multiplying by 10
   if(Digits==3 || Digits==5){
      nTickValue=nTickValue*10;
   }
   //We apply the formula to calculate the position size and assign the value to the variable
   LotSize=(AccountBalance()*MaxRiskPerTrade/100)/(SL*nTickValue);
   LotSize=MathRound(LotSize/MarketInfo(Symbol(),MODE_LOTSTEP))*MarketInfo(Symbol(),MODE_LOTSTEP);
   return LotSize;
}

//Percentage of available balance to risk in each individual trade
extern double MaxRiskPerTrade=1; //% of balance to risk in one trade
//extern int StopLoss=20; //Stop Loss in pips
 

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   MyPoint = MyPoint();
   MySlippage = MySlippage();
   PointstoPips = PointstoPips();
   //sh = BarShift;

//ArrayResize(num_array,10);
//ArrayResize(num_array1,10);

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
//Cleararray();

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  //StopTrading = false;
      //CheckTime();
 
     // if(StopTrading==false)
      
         //The trading logic of the EA goes here
      
  {
   // Check if there is an position to close
   StopTrading = false;
  CheckTime();
   CheckForClose();
   
  if(IsNewBar() == true && StopTrading==false) //TotalOpenOrders() == 0 &&
  
  
  {
//---
   // store the prices inside the variables
   //ArrayResize(num_array,10);    
   //double num_array[10];
   //num_array[0]=SI(0,2);
   //num_array[1]=SI(0,3);
   //num_array[2]=SI(0,4);
   //num_array[3]=SI(0,5);
   //num_array[4]=SI(0,6);
   //num_array[5]=SI(0,7);
   //num_array[6]=SI(0,8);
   //num_array[7]=SI(0,9);
   //num_array[8]=SI(0,10);
   //num_array[9]=SI(0,11);
  //ArrayResize(num_array1,10); 
   //double num_array1[10];
   //num_array1[0]=SI(1,2);
   //num_array1[1]=SI(1,3);
   //num_array1[2]=SI(1,4);
   //num_array1[3]=SI(1,5);
   //num_array1[4]=SI(1,6);
   //num_array1[5]=SI(1,7);
   //num_array1[6]=SI(1,8);
   //num_array1[7]=SI(1,9);
   //num_array1[8]=SI(1,10);
   //num_array1[9]=SI(1,11);
  double TalesU1=NormalizeDouble(SI(0,1),4);
  double TalesU2=NormalizeDouble(SI(0,2),4);
  double TalesU3=NormalizeDouble(SI(0,3),4);
  double TalesU4=NormalizeDouble(SI(0,4),4);
  double TalesU5=NormalizeDouble(SI(0,5),4);
  double TalesU6=NormalizeDouble(SI(0,6),4);
  
  double TalesD1=NormalizeDouble(SI(1,1),4);
  double TalesD2=NormalizeDouble(SI(1,2),4);
  double TalesD3=NormalizeDouble(SI(1,3),4);
  double TalesD4=NormalizeDouble(SI(1,4),4);
  double TalesD5=NormalizeDouble(SI(1,5),4);
  double TalesD6=NormalizeDouble(SI(1,6),4);

  double MaxU=NormalizeDouble((MathMax(TalesU2,TalesU3)),4);
  double MaxU1=NormalizeDouble((MathMax(MaxU,TalesU4)),4);
  //Print("Max U= ",MaxU, "MaxU1= " ,MaxU1,"TalesU1= ",TalesU1,"TalesU2= ",TalesU2); 
  double MinD=NormalizeDouble((MathMin((MathMin(TalesD2,TalesD3)),TalesD4)),4);
  //Print("Min D= ",MinD); 
  //double MaxValueUp=num_array[ArrayMaximum(num_array)];
  //double MaxValueindex=ArrayMaximum(num_array);
  //double MinValueDw=num_array1[ArrayMinimum(num_array1)];
  //double MinValueindex=ArrayMinimum(num_array1);
   //if (TalesU1 > MaxU1)
   
   //Print("Conditionsuccess=",TalesU1,"MaxU1= ",MaxU1);
   
  //else if (TalesU1 < MaxU1)
   //Print("conditionNot=",TalesU1,"MaxU1= ",MaxU1);
   double ATR1 = iCustom(_Symbol,_Period,"ATR", 5, 0, 1);
   //double Dopen = iOpen(_Symbol,PERIOD_D1,0);
   //double Totalpipsdiffnow = NormalizeDouble((MathAbs(Dopen-Bid)),4);
   //double Stoch1 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,1);
   double range= (iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0));
   double selltarget= (iHigh(NULL,PERIOD_D1,0)-Bid);
   double buytarget= (Ask-iLow(NULL,PERIOD_D1,0));
   double sellstop=MathMax((iHigh(NULL,PERIOD_D1,0)+5*MyPoint),Ask+StopLoss1*MyPoint);
   double buystop=MathMin((iLow(NULL,PERIOD_D1,0)-5*MyPoint),Bid-StopLoss1*MyPoint);
   double SB=NormalizeDouble((sellstop-Bid)*PointstoPips,1);
   double BS=NormalizeDouble((Ask-buystop)*PointstoPips,1);



   if(SellOrdersCount() < 2  && TalesU1 > 2*MaxU1)  //Totalpipsdiffnow < Distance &&  && Stoch1 > 20 && FastMA < SlowMA && Bid < ATRv1up&& range<Distance*MyPoint && ATR1 > 0.0005 && 
      {
         // open a sell order
         Print("open a sell order");
         //Print("SLpips= ",SB);   
         Print("Lotsize= ",CalculateLotSize(SB));    
         //Print("Talesup1= ", DoubleToString(Talesup1,4)); //(indi,digits)
         Print("Max value = ",DoubleToString(MaxU1,4));
         //Print("Max value = ",DoubleToString(MaxValueindex,5));
         //Print("Time= ",TimeHour(TimeCurrent()));  
         //Print("Totalpipsdiff= ", Totalpipsdiffnow,5);      
         OrderSend(_Symbol,OP_SELL,CalculateLotSize(SB),Bid,MySlippage,sellstop,Bid-ATR1*2,"SELL_Tales",MagicNumber);  //TP: Bid-selltarget
         //OrderSend(_Symbol,OP_SELL,LotSize,Bid,MySlippage,Bid+ATR1*SL2,Bid-ATR1*TP2,"SELL",MagicNumber);
         //OrderSend(_Symbol,OP_SELL,LotSize,Bid,MySlippage,Bid+ATR1*SL3,Bid-ATR1*TP3,"SELL",MagicNumber);
         
      }
    else if(BuyOrdersCount() < 2 && TalesD1 < 2*MinD)//&&
      {
         // open a buy order
         Print("open a buy order");
         //Print("SLpips= ",BS); 
         //Print("Lotsize= ",CalculateLotSize(BS));  
         //Print("Talesdw1= ", DoubleToString(Talesdw1,4));//(indi,digits)
        Print("Min value = ",DoubleToString(MinD,4));
        //Print("Min value = ",DoubleToString(MinValueDw,5));
         OrderSend(_Symbol,OP_BUY,CalculateLotSize(BS),Ask,MySlippage,buystop,Ask+ATR1*2,"BUY_Tales",MagicNumber);  //TP : Ask+buytarget
         //OrderSend(_Symbol,OP_BUY,LotSize,Bid,MySlippage,Ask-ATR1*SL2,Ask+ATR1*TP2,"BUY",MagicNumber);
         //OrderSend(_Symbol,OP_BUY,LotSize,Bid,MySlippage,Ask-ATR1*SL2,Ask+ATR1*TP3,"BUY",MagicNumber);
         
      }       
   
  }
  
  }

// Check if there is a new bar
bool IsNewBar()   
{        
      static datetime RegBarTime=0;
      datetime ThisBarTime = Time[0];

      if (ThisBarTime == RegBarTime)
      {
         return(false);
      }
      else
      {
         RegBarTime = ThisBarTime;
         return(true);
      }
}  



  // Returns the number of total open orders for this Symbol and MagicNumber
int TotalOpenOrders()
{
   int total_orders = 0;

   for(int order = 0; order < OrdersTotal(); order++) 
   {
      if(OrderSelect(order,SELECT_BY_POS,MODE_TRADES)==false) break;

      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == _Symbol)
         {
            total_orders++;
         }
   }

   return(total_orders);
}

// Get My Points   
double MyPoint()
{
   double CalcPoint = 0;
   
   if(_Digits == 2 || _Digits == 3) CalcPoint = 0.01;
   else if(_Digits == 4 || _Digits == 5) CalcPoint = 0.0001;
   
   return(CalcPoint);
}

// Get My Pips from point difference   
int PointstoPips()
{
   int CalcPoint1 = 0;
   
   if(_Digits == 2 || _Digits == 3) CalcPoint1 = 100;
   else if(_Digits == 4 || _Digits == 5) CalcPoint1 = 10000;
   
   return(CalcPoint1);
}

// Get My Slippage
double MySlippage()
{
   double CalcSlippage = 0;
   
   if(_Digits == 2 || _Digits == 4) CalcSlippage = Slippage;
   else if(_Digits == 3 || _Digits == 5) CalcSlippage = Slippage * 10;
   
   return(CalcSlippage);
}



////+------------------------------------------------------------------+
void CheckTime()
{
   int h=TimeHour(TimeCurrent());
   if(h>EndHour || h<StartHour)
   {
      StopTrading=true;
   }
}

//+------------------------------------------------------------------+

////+------------------------------------------------------------------+


//void Cleararray()
//{

 //  ArrayResize(num_array,10);
 //   ArrayResize(num_array1,WHOLE_ARRAY);
//}
//+------------------------------------------------------------------+
void CheckForClose()
  {
// Check if a Buy order exists
   if(BuyOrdersCount()>0)
     {
      if(OrderProfit() > BreakEvenusd)CloseAllOrder();
      //if(fast_MA[1]<slow_MA[1] && fast_MA[2]>slow_MA[2])CloseAllOrder();
     }
// Check if a Sell order exists
   else if(SellOrdersCount()>0)
     {
      if(OrderProfit() > BreakEvenusd)CloseAllOrder();
      //if(fast_MA[1]>slow_MA[1] && fast_MA[2]<slow_MA[2])CloseAllOrder();
     }
  }
//+------------------------------------------------------------------+  

void CloseAllOrder()
  {
   for(int Counter=0; Counter<=OrdersTotal()-1; Counter++)
     {
      if(!OrderSelect(Counter,SELECT_BY_POS))break;

      if(OrderMagicNumber()==MagicNumber && OrderSymbol()==_Symbol && (OrderType()==OP_BUY || OrderType()==OP_SELL))
        {
         // Get current orders information
         int CloseTicket=OrderTicket();
         double CloseLots=OrderLots();

         // Wait while trade context is busy
         while(IsTradeContextBusy()) Sleep(10);

         // Get ask or bid price
         double ClosePrice=0;
         if(OrderType()==OP_BUY)ClosePrice=MarketInfo(_Symbol,MODE_BID);
         else if(OrderType()==OP_SELL)ClosePrice=MarketInfo(_Symbol,MODE_ASK);

         // Close order
         bool res=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, 0);
         //bool res=OrderClose(CloseTicket,CloseLots,ClosePrice,MySlippage,Red);

         if(!res) Print("Error in OrderClose. Error code=",GetLastError());
         else Print("Order closed successfully.");
        }
     }
  }


//+------------------------------------------------------------------+
int BuyOrdersCount()
  {
   int BuyOrderCount=0;
   for(int i=0; i<=OrdersTotal()-1; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS))break;
      if(OrderMagicNumber()==MagicNumber && OrderSymbol()==_Symbol && OrderType()==OP_BUY)
        {
         BuyOrderCount++;
        }
     }
   return(BuyOrderCount);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SellOrdersCount()
  {
   int SellOrdersCount=0;
   for(int i=0; i<=OrdersTotal()-1; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS))break;
      if(OrderMagicNumber()==MagicNumber && OrderSymbol()==_Symbol && OrderType()==OP_SELL)
        {
         SellOrdersCount++;
        }
     }
   return(SellOrdersCount);
  }
//+------------------------------------------------------------------+

